; 
    include \masm32\include\masm32rt.inc
; 

;                               Build with
;                        Console Assemble and Link

; 

    MSIZE equ <1024*1024>

    insert_text PROTO :DWORD,:DWORD,:DWORD,:DWORD
    bldtree     PROTO :DWORD,:DWORD,:DWORD,:DWORD
    test_text   PROTO :DWORD,:DWORD
    invhex      PROTO :DWORD

    BCNT equ 12

    mhex$ MACRO dwval
      IFNDEF @_hx
      .data?
        @_hx db 12 dup (?)
      .code
      ENDIF
      invoke dw2hex,dwval,ADDR @_hx
      invoke invhex,ADDR @_hx
      EXITM <OFFSET @_hx>
    ENDM

  .data
    w0 db "x",0
    w1 db "xx",0
    w2 db "xxx",0
    w3 db "xxxx",0
    w4 db "xxxxx",0

    n0 db "zero",0
    n1 db "one",0
    n2 db "two",0
    n3 db "three",0
    n4 db "four",0
    n5 db "five",0
    n6 db "six",0
    n7 db "seven",0
    n8 db "eight",0
    n9 db "nine",0

    m0 db "zzzzz",0
    m1 db "zzzz",0
    m2 db "zzz",0
    m3 db "zz",0
    m4 db "z",0

    array dd w0,w1,w2,w3,w4,n0,n1,n2,n3,n4,n5,n6,n7,n8,n9,m0,m1,m2,m3,m4

    .code

start:
  
; 

    call main

    exit

; 

main proc

    LOCAL hmem  :DWORD                  ; pointer to main buffer
    LOCAL cloc  :DWORD                  ; current location in buffer

    mov cloc, 0                         ; set current location to zero
    mov hmem, alloc$(MSIZE)             ; allocate 1st meg of memory

    push ebx
    push esi
    push edi


 ;     --------------
 ;     duplicate test
 ;     --------------
 ;     fn insert_text,"word",hmem,ADDR cloc,999
 ;     fn insert_text,"word",hmem,ADDR cloc,1000
 ;     fn insert_text,"word",hmem,ADDR cloc,1001
 ;     fn insert_text,"word",hmem,ADDR cloc,1002
 ;     fn insert_text,"word",hmem,ADDR cloc,1003
 ; 
 ;     fn test_text,"word",hmem
 ; 
 ;     print str$(eax),13,10


  ; -------------------------------------------
  ; load the table with words and return values
  ; -------------------------------------------
    mov edi, LENGTHOF array             ; set a counter
    mov esi, OFFSET array
    xor ebx, ebx
  @@:
    add ebx, 1                          ; increment the return value
    fn insert_text,[esi],hmem,ADDR cloc,ebx
    test eax, eax
    jz nxt
    print mhex$(eax),13,10              ; display if not zero
  nxt:
    add esi, 4
    sub edi, 1
    jnz @B

  ; --------------------------------------------
  ; test the words and display the return values
  ; --------------------------------------------
    mov edi, LENGTHOF array             ; set a counter
    mov esi, OFFSET array
  @@:
    fn test_text,[esi],hmem
    push eax
    print [esi]," return value = "
    pop eax
    print str$(eax),13,10               ; display the return value
    add esi, 4
    sub edi, 1
    jnz @B
  ; --------------------------------------------

    ;; test OutputFile("result.bin",hmem,2048), eax

    free$ hmem

  ; ========================
  ; real men debug in HEX :)
  ; ========================

    ;; fn WinExec,"hexedit.exe result.bin",1

    mov ecx, input(13,10,"Press ENTER to exit ",62," ")

    pop edi
    pop esi
    pop ebx


    ret

main endp

; 

insert_text proc txt:DWORD,hmem:DWORD,cloc:DWORD,rval:DWORD

  ; ----------------
  ; test memory here
  ; ----------------

    invoke bldtree,txt,hmem,cloc,rval

    ret

insert_text endp

; 

    tchar equ <BYTE  PTR [ecx]>
    lnode equ <DWORD PTR [ecx+4]>
    rnode equ <DWORD PTR [ecx+8]>

bldtree proc txt:DWORD,hmem:DWORD,cloc:DWORD,rval:DWORD

    LOCAL next  :DWORD

    push ebx
    push esi
    push edi

    mov eax, cloc                       ; load current location pointer into EAX
    mov edx, [eax]                      ; dereference it into EDX
    mov next, edx                       ; copy EDX to local variable

    xor eax, eax                        ; prevent stall in AL

    mov edi, txt                        ; load text address in EDI
    mov ecx, hmem                       ; load base address in ECX
    jmp strt

  pre:
    add edi, 1
  strt:
    mov al, [edi]

    ; ============================

    .if al != 0

      .if tchar == 0
        .if lnode == 0              ; empty node
          mov tchar, al             ; WRITE character
          call alloc_lnode
          jmp pre                   ; get next character
        .else                       ; used node
          .if rnode != 0
            mov ecx, rnode          ; load rnode and loop back
            jmp strt                ; loop back
          .else                     ; if rnode != 0
            call alloc_rnode
            jmp strt                ; loop back
          .endif
        .endif

      .elseif tchar != 0
        .if tchar == al             ; if match
          .if lnode != 0
            mov ecx, lnode          ; load left node and loop back
            jmp pre                 ; get next character
          .else
            call alloc_rnode
            jmp strt
          .endif

        .elseif tchar != al
          .if rnode != 0
            mov ecx, rnode          ; load rnode and loop back
            jmp strt                ; loop back
          .else                     ; if rnode != 0
            call alloc_rnode
            jmp strt                ; loop back
          .endif
        .endif

      .endif

    ; ============================

    .else
    iszero:
      .if tchar == 0
        .if lnode == 0
          mov tchar, al
          mov edx, rval             ; write return value if empty node
          mov lnode, edx
          jmp btout
        .endif
      .endif

      .if tchar != 0
        .if rnode != 0
          mov ecx, rnode
          jmp iszero
        .else
          call alloc_rnode
          jmp iszero
        .endif

      .endif
    .endif

    ; ============================

    jmp btout

    align 4
    alloc_rnode:
      add next, BCNT
      mov edx, hmem
      add edx, next
      mov rnode, edx
      mov ecx, rnode
    retn

    align 4
    alloc_lnode:
      add next, BCNT
      mov edx, hmem
      add edx, next
      mov lnode, edx
      mov ecx, lnode
    retn

  btout:

  ; -----------------------------------
  ; update the current location pointer
  ; -----------------------------------
    mov ecx, cloc
    mov edx, next
    mov [ecx], edx

    pop edi
    pop esi
    pop ebx

    ret

bldtree endp

; 

test_text proc txt:DWORD,hmem:DWORD

    push ebx
    push esi
    push edi

    mov edi, txt
    mov ecx, hmem
    jmp strt

  pre:
    add edi, 1
  strt:
    mov al, [edi]

  ; =====================

    .if al != 0
      .if tchar == al
        mov ecx, lnode          ; move up left node
        test ecx, ecx
        jz notfound
        jmp pre

      .else
        mov ecx, rnode          ; move across right node
        test ecx, ecx
        jz notfound
        jmp strt
      .endif

  ; =====================

      .elseif al == 0
        zero:
        .if lnode != 0
          .if tchar == 0
            mov eax, lnode        ; load left node into EAX and exit
            jmp quit
          .elseif tchar != 0
            .if rnode != 0
              mov ecx, rnode
              jmp zero
 ;             .elseif rnode == 0
 ;               add ecx, BCNT
 ;               jmp zero
            .endif
          .endif
        .endif
    .endif

  ; =====================

    jmp quit

  notfound:
    mov eax, -1                 ; return -1 on word not found

  quit:

    pop edi
    pop esi
    pop ebx

    ret

test_text endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4

invhex proc src:DWORD

    push ebx
    push esi

    mov esi, [esp+12]

    mov ax, [esi]
    mov bx, [esi+2]
    mov cx, [esi+4]
    mov dx, [esi+6]
    mov [esi+6], ax
    mov [esi+4], bx
    mov [esi+2], cx
    mov [esi], dx

    pop esi
    pop ebx

    ret 4

invhex endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start

                    0
                    |
                0---x
                |
            0---x
            |
        0---x
        |
    0---x
    |
    x


    0       0   0   0       0   0   0       0   0
    |       |   |   |       |   |   |       |   |
    d---0---b---w   d---0---b---w   d---0---w---b
    |               |               |
    s---0           s               s
    |               |               |
    v               d               o
    |               |               |
    o               o               t
    |               |               |
    m---------------l---------------s
    |













